aboutsummaryrefslogtreecommitdiffstats
path: root/bootstrap/install
diff options
context:
space:
mode:
authorene <ene@sils.li>2023-02-19 13:35:40 +0100
committerene <ene@sils.li>2023-02-19 13:35:40 +0100
commit4d47089b4bd7f6101e258852cf9c35230bd1c89b (patch)
treee46c5305ca2a1dc070e5a3d1d44c5e81b835f9bf /bootstrap/install
parentFeat: Add 'spawn' host, to simply create a bootable base (diff)
downloadnixos-config-4d47089b4bd7f6101e258852cf9c35230bd1c89b.zip
Feat(bootstrap): Add a Script to make nix run with bootstrap viable
Diffstat (limited to 'bootstrap/install')
-rwxr-xr-xbootstrap/install127
1 files changed, 127 insertions, 0 deletions
diff --git a/bootstrap/install b/bootstrap/install
new file mode 100755
index 00000000..f281e1dc
--- /dev/null
+++ b/bootstrap/install
@@ -0,0 +1,127 @@
+#!/bin/sh
+# shellcheck disable=SC2086
+# shellcheck source=/dev/null
+. ~/.local/lib/shell/lib
+export LIB_TEMP_DIR_FOR_SCRIPT="$(mktemp -d)"
+bsc() {
+ msg2 "$(btrfs subvolume create "$1" || dien "Creating of subvol $1")";
+}
+
+mne() {
+ mount --mkdir --options compress-force=zstd:15,subvol="$1" $DISK_ROOT "$2" || dien "Mounting of $1";
+}
+
+
+available_disks="$(mktmp)";
+lsblk -J | jq '.[] | map(.name) | [foreach .[] as $item ({item: null, index: -1}; {$item, index: (.index + 1)})]' > $available_disks;
+
+
+[ "$(jq '.[]' "$available_disks" | wc -l)" -eq 0 ] && die "No disks found"
+msg "Select a disk to format:\n"
+
+i=9999; # nobody will have so many disks attached
+
+while ! jq -e --argjson i "$i" '.[$i]' "$available_disks" > /dev/null 2>&1; do
+ for disk in $(jq -c '.[]' "$available_disks" ); do
+ printf "%4s) %s \n" "$(echo "$disk" | jq '.index')" "$(echo "$disk" | jq '.item' | tr -d "\"")";
+ done
+ printf "%4s) Exit\n" "q"
+ readp "Enter a option: " disk
+
+ if [ $disk = "q" ];then
+ exit 1
+ else
+ i="$disk"
+ fi
+ if jq -e --argjson i "$i" 'nth($i)' "$available_disks" > /dev/null 2>&1; then
+ disk=$(mktmp);
+ jq -e --argjson i "$i" 'nth($i)' "$available_disks" > "$disk";
+ else
+ warning "No disk selected. Select a disk to continue.\n"
+ fi
+done
+
+readp "Do you really want to delete all data on disk $(jq '.item' "$disk")? [N/y]: " result
+case $result in
+ [Yy])
+ msg "Great, deleting everything..."
+ disk="$(jq '.item' "$disk" | tr -d "\"")"
+ ;;
+ *)
+ msg "Sure, keep your data"
+ exit 1
+ ;;
+esac
+
+sgdisk -Z "/dev/${disk}" || dien "Zapping"
+
+sgdisk -n 1:0:+550M -n 2:0:"$ENDSECTOR" -t 1:ef00 -t 2:8300 "/dev/${disk}" || dien "Partitioning"
+
+case "$disk" in
+ "nvme"*)
+ export DISK_EFI="/dev/${disk}"p1
+ export DISK_ROOT="/dev/${disk}"p2
+ ;;
+ "sd"* |"vd"*)
+ export DISK_EFI="/dev/${disk}"1
+ export DISK_ROOT="/dev/${disk}"2
+ ;;
+ *)
+ die "The disk type: ${disk} is not yet supported!"
+ ;;
+esac
+
+msg "Started Formatting..."
+mkfs.fat -F32 "$DISK_EFI" || dien "Formatting(fat32)"
+mkfs.btrfs "$DISK_ROOT" || dien "Formatting(btrfs)"
+
+
+msg "Mounting..."
+mount -t btrfs $DISK_ROOT /mnt
+cd /mnt || die "(Bug): no /mnt"
+bsc nix-store
+bsc persistent-storage
+bsc storage/nixos-config
+cd /
+umount -R /mnt
+mount -t tmpfs none /mnt
+mount --mkdir "$DISK_EFI" /mnt/boot
+
+mne nix-store /mnt/nix
+mne persistent-storage /mnt/srv
+
+mount --mkdir --options bind /mnt/srv/nixos-config /mnt/etc/nixos
+
+msg "Finished mounting and generating btrfs subvolumes"
+readp "Do you want to continue with nixos-install? [N/y]: " result
+case $result in
+ [Yy])
+ msg "Great, select a host-config:"
+ hosts=$(mktmp);
+ host="";
+ awk -F "." '/nixosConfiguration/{print $2}' "$(tmp 'curl https://git.sils.li/ene/nixos-config/raw/branch/prime/flake.nix')" | awk '{print $1}' > $hosts;
+
+ while ! awk -v host $host '{$0 ~ host}' "$hosts" && [ "$host" != "" ]; do
+ i=1;
+ while read -r ho ; do
+ printf "%4s) %s \n" "$i" "$ho";
+ i=$((i+1));
+ done < "$hosts"
+ printf "%4s) Exit\n" "q"
+ readp "Enter a option: " host
+
+ [ $host = "q" ] && exit 1
+ if awk -v host $host '{$0 ~ host}' "$hosts" && [ "$host" != "" ]; then
+ host=$(awk -v i $host 'NR==i' "$hosts");
+ else
+ warning "No disk selected. Select a disk to continue.\n"
+ fi
+ done
+ nixos-install --flake https://git.sils.li/ene/nixos-config#${host} --no-root-passwd
+ ;;
+ *)
+ msg "Sure, do it yourself"
+ exit 1
+ ;;
+esac
+if [ -d "$LIB_TEMP_DIR_FOR_SCRIPT" ];then rm -r "$LIB_TEMP_DIR_FOR_SCRIPT"; fi